#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""Test per gli esercizi del Lab XX informatica@sefa 2018/2019

"""
import importlib
import unittest
import sys

ex_name = 'ghms2'
ex_functions = ['ghms2']

# Importa le soluzioni degli esercizi
lab = None
try:
    lab = importlib.__import__(ex_name)
except Exception:
    msg = """ERROR: Problema col file {0}.py. Forse
    -- forse non è presente in questa cartella
    -- oppure contiene errori che non lo rendono eseguibile
    
    Prova ad eseguire '$ python3 {0}.py'""".format(ex_name)
    print(msg, file=sys.stderr)
    sys.exit(-1)

f_objects = {}
for f_name in ex_functions:
    try:
        f_object = lab.__dict__[f_name]
        f_objects[f_name] = f_object
    except KeyError:
        msg = "ESERCIZIO MANCANTE: Funzione {1} non presente in file {0}.py".format(
            ex_name, f_name)
        print(msg, file=sys.stderr)

# Caricale nel namespace
globals().update(f_objects)


class TestGHMS2(unittest.TestCase):
    def _verify_ghms(self, secondi, text):
        result = ghms2(secondi)
        messaggio = "\nTEST FAIL> La funzione ghms2({})\n dovrebbe produrre: '{}',\n invece produce:    '{}'".format(
            secondi, text, result)
        self.assertEqual(text, ghms2(secondi), msg=messaggio)

    def test_examples_cases1(self):
        self._verify_ghms(0, "0 secondi.")

    def test_examples_cases2(self):
        self._verify_ghms(2348, "39 minuti e 8 secondi.")

    def test_examples_cases3(self):
        self._verify_ghms(3840, "1 ora e 4 minuti.")

    def test_examples_cases4(self):
        self._verify_ghms(122456, "1 giorno, 10 ore e 56 secondi.")

    def test_examples_cases5(self):
        self._verify_ghms(60 * 60 * 48, "2 giorni.")

    def test_examples_cases6(self):
        self._verify_ghms(60, "1 minuto.")

    def test_examples_cases7(self):
        self._verify_ghms(1, "1 secondo.")

    def test_ghms2_positive(self):
        msg = "\nTEST FAIL> ghms2(-3) dovrebbe sollevare un ValueError perché ha un parametro < 0."
        with self.assertRaises(ValueError, msg=msg):
            ghms2(-3)


if __name__ == '__main__':
    unittest.main()
